import 'package:hmg_patient_app/core/enum/viewstate.dart';
import 'package:hmg_patient_app/core/viewModels/pharmacyModule/MostViewedViewModel.dart';
import 'package:hmg_patient_app/pages/base/base_view.dart';
import 'package:hmg_patient_app/pages/final_products_page.dart';
import 'package:hmg_patient_app/pages/pharmacies/widgets/ProductTileItem.dart';
import 'package:hmg_patient_app/pages/pharmacies/widgets/home/ViewAllHomeWidget.dart';
import 'package:hmg_patient_app/uitl/translations_delegate_base.dart';
import 'package:hmg_patient_app/widgets/data_display/text.dart';
import 'package:hmg_patient_app/widgets/others/network_base_view.dart';
import 'package:flutter/material.dart';

class MostViewedWidget extends StatelessWidget {
  const MostViewedWidget({Key? key}) : super(key: key);

  @override
  Widget build(BuildContext context) {
    return BaseView<MostViewedViewModel>(
        onModelReady: (model) => model.getMostViewedProducts(),
        allowAny: true,
        builder: (_, model, wi) => NetworkBaseView(
              isLocalLoader: true,
              baseViewModel: model,
              child: Container(
                child: Column(
                  children: [
                    ViewAllHomeWidget(
                        TranslationBase.of(context).mostViewed,
                        FinalProductsPage(
                          id: "",
                          productType: 4,
                        )),
                    if (model.state != ViewState.BusyLocal)
                      Container(
                        height: MediaQuery.of(context).size.height / 3 + 1,
                        child: ListView.builder(
                          itemBuilder: (ctx, i) => ProductTileItem(
                              model.mostViewedProducts[i],
                              MediaQuery.of(context).size.height / 4 + 20),
                          scrollDirection: Axis.horizontal,
                          itemCount: model.mostViewedProducts.length,
                        ),
                      )
                    else
                      Container(
                        height: 80,
                        child: Center(
                          child: CircularProgressIndicator(
                            backgroundColor: Colors.white,
                            valueColor: AlwaysStoppedAnimation<Color>(
                              Colors.grey[500]!,
                            ),
                          ),
                        ),
                      ),
                  ],
                ),
              ),
            ));
  }
}
